/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 * 
 * Many parts of this code are based on webdeveloper extension 
 * http://webdeveloper.mozdev.org
 * 
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *   Jawahar Swaminathan <jawahar@ebi.ac.uk>
 */


/*
 * doXxxx function's
 */

var biobar_optionsDataString  = new Array();
var biobar_optionsDataBoolean  = new Array();
var biobar_optionsDataInteger  = new Array();
var biobar_toolDescription    = null;
var biobar_toolURL            = null;

function biobar_changePage(pageList) {
	biobar_storeOptions();

	document.getElementById("biobar-options-iframe").setAttribute("src", pageList.selectedItem.value);
	//  alert('Value is '+document.getElementById("biobar-options-iframe").setAttribute("src", pageList.selectedItem.getAttribute("value")));
}


//function biobar_initializeRCSB() {
//	const pageDocument       = document.getElementById("biobar-options-iframe").contentDocument;
//	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

//	if(typeof biobar_optionsDataString["biobar.RCSB.name.server"] != "undefined") {
//		pageDocument.getElementById("biobar.RCSB.name.server").value = biobar_optionsDataString["biobar.RCSB.name.server"];
//	} else if(preferencesService.prefHasUserValue("biobar.RCSB.name.server")) {
//		pageDocument.getElementById("biobar.RCSB.name.server").value = preferencesService.getCharPref("biobar.RCSB.name.server");
//	}
//}

function biobar_initializeOCA() {
	const pageDocument       = document.getElementById("biobar-options-iframe").contentDocument;
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

	if(typeof biobar_optionsDataString["biobar.OCA.name.server"] != "undefined") {
		pageDocument.getElementById("biobar.OCA.name.server").value = biobar_optionsDataString["biobar.OCA.name.server"];
	} else if(preferencesService.prefHasUserValue("biobar.OCA.name.server")) {
		pageDocument.getElementById("biobar.OCA.name.server").value = preferencesService.getCharPref("biobar.OCA.name.server");
	}
}

function biobar_initializeExpasy() {
	const pageDocument       = document.getElementById("biobar-options-iframe").contentDocument;
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

	if(typeof biobar_optionsDataString["biobar.Expasy.name.server"] != "undefined") {
		pageDocument.getElementById("biobar.Expasy.name.server").value = biobar_optionsDataString["biobar.Expasy.name.server"];
	} else if(preferencesService.prefHasUserValue("biobar.Expasy.name.server")) {
		pageDocument.getElementById("biobar.Expasy.name.server").value = preferencesService.getCharPref("biobar.Expasy.name.server");
	}
}

function biobar_initializeFlybase() {
	const pageDocument       = document.getElementById("biobar-options-iframe").contentDocument;
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

	if(typeof biobar_optionsDataString["biobar.Flybase.name.server"] != "undefined") {
		pageDocument.getElementById("biobar.Flybase.name.server").value = biobar_optionsDataString["biobar.Flybase.name.server"];
	} else if(preferencesService.prefHasUserValue("biobar.Flybase.name.server")) {
		pageDocument.getElementById("biobar.Flybase.name.server").value = preferencesService.getCharPref("biobar.Flybase.name.server");
	}
}

function biobar_initializencbi() {
	const pageDocument       = document.getElementById("biobar-options-iframe").contentDocument;
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

	if(typeof biobar_optionsDataString["biobar.NCBI.holding"] != "undefined") {
		pageDocument.getElementById("biobar.NCBI.holding").value = biobar_optionsDataString["biobar.NCBI.holding"];
	} else if(preferencesService.prefHasUserValue("biobar.NCBI.holding")) {
		pageDocument.getElementById("biobar.NCBI.holding").value = preferencesService.getCharPref("biobar.NCBI.holding");
	}
}

function  biobar_initializetoolbar() {
	const pageDocument       = document.getElementById("biobar-options-iframe").contentDocument;
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	//if sequences are to be shown
	if(typeof biobar_optionsDataBoolean["biobar.sequences"] != "undefined")
	{
		pageDocument.getElementById("biobar.sequences").checked = preferencesService.getBoolPref("biobar.sequences");
	}
	else if (preferencesService.prefHasUserValue("biobar.sequences"))
	{
		pageDocument.getElementById("biobar.sequences").checked = preferencesService.getBoolPref("biobar.sequences");
	}

	//if structures are to be shown
	if(typeof biobar_optionsDataBoolean["biobar.structures"] != "undefined")
	{
		pageDocument.getElementById("biobar.structures").checked = preferencesService.getBoolPref("biobar.structures");
	}
	else if (preferencesService.prefHasUserValue("biobar.structures"))
	{
		pageDocument.getElementById("biobar.structures").checked = preferencesService.getBoolPref("biobar.structures");
	}

	//if function are to be shown

	if(typeof biobar_optionsDataBoolean["biobar.function"] != "undefined")
	{
		pageDocument.getElementById("biobar.function").checked = preferencesService.getBoolPref("biobar.function");
	}
	else if (preferencesService.prefHasUserValue("biobar.function"))
	{
		pageDocument.getElementById("biobar.function").checked = preferencesService.getBoolPref("biobar.function");
	}

	// if plant databases are to be shown

	if(typeof biobar_optionsDataBoolean["biobar.plant"] != "undefined")
	{
		pageDocument.getElementById("biobar.plant").checked = preferencesService.getBoolPref("biobar.plant");
	}
	else if (preferencesService.prefHasUserValue("biobar.plant"))
	{
		pageDocument.getElementById("biobar.plant").checked = preferencesService.getBoolPref("biobar.plant");
	}

	// if animal databases are to be shown

	if(typeof biobar_optionsDataBoolean["biobar.animal"] != "undefined")
	{
		pageDocument.getElementById("biobar.animal").checked = preferencesService.getBoolPref("biobar.animal");
	}
	else if (preferencesService.prefHasUserValue("biobar.animal"))
	{
		pageDocument.getElementById("biobar.animal").checked = preferencesService.getBoolPref("biobar.animal");
	}
	// if fungal databases are to be shown

	if(typeof biobar_optionsDataBoolean["biobar.fungus"] != "undefined")
	{
		pageDocument.getElementById("biobar.fungus").checked = preferencesService.getBoolPref("biobar.fungus");
	}
	else if (preferencesService.prefHasUserValue("biobar.fungus"))
	{
		pageDocument.getElementById("biobar.fungus").checked = preferencesService.getBoolPref("biobar.fungus");
	}

	//if EBI is to be shown

	if(typeof biobar_optionsDataBoolean["biobar.EBI"] != "undefined")
	{
		pageDocument.getElementById("biobar.EBI").checked = preferencesService.getBoolPref("biobar.EBI");
	}
	else if (preferencesService.prefHasUserValue("biobar.EBI"))
	{
		pageDocument.getElementById("biobar.EBI").checked = preferencesService.getBoolPref("biobar.EBI");
	}



	// if NCBI is to be shown


	if(typeof biobar_optionsDataBoolean["biobar.NCBI"] != "undefined")
	{
		pageDocument.getElementById("biobar.NCBI").checked = preferencesService.getBoolPref("biobar.NCBI");
	}
	else if (preferencesService.prefHasUserValue("biobar.NCBI"))
	{
		pageDocument.getElementById("biobar.NCBI").checked = preferencesService.getBoolPref("biobar.NCBI");
	}
	// if DDBJ is to be shown

	if(typeof biobar_optionsDataBoolean["biobar.DDBJ"] != "undefined")
	{
		pageDocument.getElementById("biobar.DDBJ").checked = preferencesService.getBoolPref("biobar.DDBJ");
	}
	else if (preferencesService.prefHasUserValue("biobar.DDBJ"))
	{
		pageDocument.getElementById("biobar.DDBJ").checked = preferencesService.getBoolPref("biobar.DDBJ");
	}
	if(typeof biobar_optionsDataBoolean["biobar.groups.preference"] != "undefined")
	{
		pageDocument.getElementById("biobar.group.preference").checked = preferencesService.getBoolPref("biobar.group.preference");
	}
	else if (preferencesService.prefHasUserValue("biobar.group.preference"))
	{
		pageDocument.getElementById("biobar.group.preference").checked = preferencesService.getBoolPref("biobar.group.preference");
	}
	if(typeof biobar_optionsDataString["biobar.default.database"] != "undefined")
	{
				pageDocument.getElementById("biobar.default.database").value = preferencesService.getCharPref("biobar.default.database");
	}
	else if (preferencesService.prefHasUserValue("biobar.default.database"))
	{
				pageDocument.getElementById("biobar.default.database").value = preferencesService.getCharPref("biobar.default.database");
	}
	if(typeof biobar_optionsDataString["biobar.tab.preference"] != "undefined")
		pageDocument.getElementById("biobar.tab.preference").value = preferencesService.getCharPref("biobar.tab.preference");
	else if (preferencesService.prefHasUserValue("biobar.tab.preference"))
	{
		pageDocument.getElementById("biobar.tab.preference").value = preferencesService.getCharPref("biobar.tab.preference");
	}
}

// Saves the user's options
function biobar_saveOptions() {
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	const string = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	var parentWindow = null;
	var option      = null;
	var optionValue = null;

	// Make sure current page is stored
	biobar_storeOptions();
	for(option in biobar_optionsDataString) {
		optionValue = biobar_optionsDataString[option];

		// If the option value is set or the preference currently has a value

		if(optionValue || preferencesService.prefHasUserValue(option)) {
			string.data = optionValue;

			preferencesService.setComplexValue(option, Components.interfaces.nsISupportsString, string);
		}

	}

	//Store the booleans from the checkboxes.

	for (option in biobar_optionsDataBoolean) {
		preferencesService.setBoolPref(option, biobar_optionsDataBoolean[option]);
	}
	// Store the Intergers
	for(option in biobar_optionsDataInteger)
	{
		optionValue = biobar_optionsDataInteger[option];

		// If the option value is set
		if(optionValue)
		{
			preferencesService.setIntPref(option, optionValue);
		}
		else if(preferencesService.prefHasUserValue(option))
		{
			preferencesService.clearUserPref(option);
		}
	}


}

function biobar_storeOptions() {
	const iFrame       = document.getElementById("biobar-options-iframe");
	const iFrameSrc    = iFrame.getAttribute("src");
	const pageDocument = iFrame.contentDocument;
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

	var childNodes  = null;
	var description = null;
	var i           = 0;
	var listItem    = null;

//	if(iFrameSrc.indexOf("rcsb") != -1) {
//		biobar_optionsDataString["biobar.RCSB.name.server"]              = pageDocument.getElementById("biobar.RCSB.name.server").value;
		//      alert('value is '+pageDocument.getElementById("biobar.RCSB.name.server").value);
//	} else 
	if (iFrameSrc.indexOf("oca") != -1) {
		biobar_optionsDataString["biobar.OCA.name.server"]               = pageDocument.getElementById("biobar.OCA.name.server").value;
	} else if
	(iFrameSrc.indexOf("expasy") != -1) {
		biobar_optionsDataString["biobar.Expasy.name.server"]            = pageDocument.getElementById("biobar.Expasy.name.server").value;
	} else if
	(iFrameSrc.indexOf("flybase") != -1) {
		biobar_optionsDataString["biobar.Flybase.name.server"]           = pageDocument.getElementById("biobar.Flybase.name.server").value;
	} else if
	(iFrameSrc.indexOf("ncbi") != -1) {
		biobar_optionsDataString["biobar.NCBI.holding"]           = pageDocument.getElementById("biobar.NCBI.holding").value;
	} else if (iFrameSrc.indexOf("toolbar") != -1) {
		biobar_optionsDataBoolean["biobar.sequences"]               = pageDocument.getElementById("biobar.sequences").checked;
		biobar_optionsDataBoolean["biobar.structures"]              = pageDocument.getElementById("biobar.structures").checked;
		biobar_optionsDataBoolean["biobar.function"]                = pageDocument.getElementById("biobar.function").checked;
		biobar_optionsDataBoolean["biobar.plant"]                   = pageDocument.getElementById("biobar.plant").checked;
		biobar_optionsDataBoolean["biobar.animal"]                  = pageDocument.getElementById("biobar.animal").checked;
		biobar_optionsDataBoolean["biobar.EBI"]                    = pageDocument.getElementById("biobar.EBI").checked;
		biobar_optionsDataBoolean["biobar.NCBI"]                    = pageDocument.getElementById("biobar.NCBI").checked;
		biobar_optionsDataBoolean["biobar.DDBJ"]                    = pageDocument.getElementById("biobar.DDBJ").checked;
		biobar_optionsDataBoolean["biobar.fungus"]                  = pageDocument.getElementById("biobar.fungus").checked;
		biobar_optionsDataBoolean["biobar.group.preference"]        = pageDocument.getElementById("biobar.group.preference").checked;
		biobar_optionsDataString["biobar.default.database"]         = pageDocument.getElementById("biobar.default.database").value;
		biobar_optionsDataString["biobar.tab.preference"]           = pageDocument.getElementById("biobar.tab.preference").value;
	} else if
	(iFrameSrc.indexOf("custlinks") != -1)
	{

		const toolBox = pageDocument.getElementById("biobar-listbox");
		var toolCount = 0;
		var url       = null;

		// If the tool count preference is set
		if(preferencesService.prefHasUserValue("biobar.tool.count"))
		{
			toolCount = preferencesService.getIntPref("biobar.tool.count");
		}

		// Loop through the previous tools
		for(i = 1; i <= toolCount; i++)
		{
			description = "biobar.tool." + i + ".description";
			url         = "biobar.tool." + i + ".url";
			biobar_optionsDataString[description] = "";
			biobar_optionsDataString[url]         = "";
		}

		toolCount = toolBox.getRowCount();

		// Loop through the possible tools
		for(i = 1; i <= toolCount; i++)
		{
			description = "biobar.tool." + i + ".description";
			listItem    = toolBox.getItemAtIndex(i - 1);
			childNodes  = listItem.childNodes;
			url         = "biobar.tool." + i + ".url";
			biobar_optionsDataString[description] = listItem.childNodes[0].getAttribute("label").trim();
			biobar_optionsDataString[url]         = listItem.childNodes[1].getAttribute("label").trim();
		}

		biobar_optionsDataInteger["biobar.tool.count"] = toolCount;
	}
}

function biobar_initializeOptions()
{
	const selectedPage = document.getElementById("biobar-page-list").selectedItem.getAttribute("value");
//	if(selectedPage.indexOf("rcsb") != -1)
//	{
//		biobar_initializeRCSB();
//	}

	if(selectedPage.indexOf("oca") != -1)
	{
		biobar_initializeOCA();
	}

	if(selectedPage.indexOf("expasy") != -1)
	{
		biobar_initializeExpasy();
	}

	if(selectedPage.indexOf("flybase") != -1)
	{
		biobar_initializeFlybase();
	}

	if(selectedPage.indexOf("toolbar") != -1)
	{
		biobar_makeDefault();
		biobar_initializetoolbar();
	}

	if(selectedPage.indexOf("ncbi") != -1)
	{
		biobar_initializencbi();
	}
	if(selectedPage.indexOf("custlinks") !=-1)
	{
		biobar_initializeCustom();
	}

}


// Initializes the tools page
function biobar_initializeCustom()
{
	const pageDocument       = document.getElementById("biobar-options-iframe").contentDocument;
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	const toolBox            = pageDocument.getElementById("biobar-listbox");

	var description      = null;
	var descriptionValue = null;
	var listCell         = null;
	var listItem         = null;
	var toolCount        = 0;
	var url              = null;
	var urlValue         = null;

	// If the tool count preference is set
	if(typeof biobar_optionsDataInteger["biobar.tool.count"] != "undefined")
	{
		toolCount = biobar_optionsDataInteger["biobar.tool.count"];
	}
	else if(preferencesService.prefHasUserValue("biobar.tool.count"))
	{
		toolCount = preferencesService.getIntPref("biobar.tool.count");
	}

	// Loop through the possible tools
	for(var i = 1; i <= toolCount; i++)
	{
		description = "biobar.tool." + i + ".description";
		url         = "biobar.tool." + i + ".url";

		// If the description is set
		if(typeof biobar_optionsDataString[description] != "undefined")
		{
			descriptionValue = biobar_optionsDataString[description].trim();
		}
		else if(preferencesService.prefHasUserValue(description))
		{
			descriptionValue = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
		}
		else
		{
			descriptionValue = null;
		}

		// If the URL is set
		if(typeof biobar_optionsDataString[url] != "undefined")
		{
			urlValue = biobar_optionsDataString[url].trim();
		}
		else if(preferencesService.prefHasUserValue(url))
		{
			urlValue = preferencesService.getComplexValue(url, Components.interfaces.nsISupportsString).data.trim();
		}
		else
		{
			urlValue = null;
		}

		// If the description and URL are set
		if(descriptionValue && urlValue)
		{
			listItem = pageDocument.createElement("listitem");

			listCell = pageDocument.createElement("listcell");
			listCell.setAttribute("label", descriptionValue);
			listItem.appendChild(listCell);

			listCell = pageDocument.createElement("listcell");
			listCell.setAttribute("label", urlValue);
			listCell.setAttribute("crop", "end");
			listItem.appendChild(listCell);
			toolBox.appendChild(listItem);
		}
	}
}



function biobar_addLink()
{
	const pageDocument = document.getElementById("biobar-options-iframe").contentDocument;
	const toolBox      = pageDocument.getElementById("biobar-listbox");

	window.openDialog("chrome://biobar/content/options/dialogs/custlink.xul", "biobar-tool-dialog", "centerscreen,chrome,modal", "add")
	;

	// If the description and URL are set
	if(biobar_toolDescription && biobar_toolURL)
	{
		var listCell = pageDocument.createElement("listcell");
		var listItem = pageDocument.createElement("listitem");

		listCell.setAttribute("label", biobar_toolDescription);
		listItem.appendChild(listCell);

		listCell = pageDocument.createElement("listcell");
		listCell.setAttribute("label", biobar_toolURL);
		listCell.setAttribute("crop", "end");
		listItem.appendChild(listCell);

		toolBox.selectItem(toolBox.appendChild(listItem));
	}
}

function biobar_deleteLink()
{
	const pageDocument = document.getElementById("biobar-options-iframe").contentDocument;
	const stringBundle = document.getElementById("biobar-string-bundle");
	const toolBox      = pageDocument.getElementById("biobar-listbox");
	const selectedItem = toolBox.selectedItem;
	// If an item is selected and the deletion is confirmed
	if(selectedItem && confirm(stringBundle.getString("biobar_toolDeleteConfirmation")))
	{
		toolBox.removeChild(selectedItem);
	}
}

function biobar_editLink()
{
	const pageDocument = document.getElementById("biobar-options-iframe").contentDocument;
	const toolBox      = pageDocument.getElementById("biobar-listbox");
	const selectedItem = toolBox.selectedItem;

	// If an option is selected
	if(selectedItem)
	{
		window.openDialog("chrome://biobar/content/options/dialogs/custlink.xul", "biobar-tool-dialog", "centerscreen,chrome,modal", "edit", selectedItem.childNodes[0].getAttribute("label"), selectedItem.childNodes[1].getAttribute("label"));

		// If the description and url are set
		if(biobar_toolDescription && biobar_toolURL)
		{
			var listCell = pageDocument.createElement("listcell");

			biobar_removeAllChildNodes(selectedItem);

			listCell.setAttribute("label", biobar_toolDescription);
			selectedItem.appendChild(listCell);

			listCell = pageDocument.createElement("listcell");
			listCell.setAttribute("label", biobar_toolURL);
			listCell.setAttribute("crop", "end");
			selectedItem.appendChild(listCell);

		}
	}
}

function biobar_makeDefault() {
	var biobar_XMLFile;
	var localXMLFile="BiobarSearch.xml";
	var file=Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD",Components.interfaces.nsIFile);
	file.append(localXMLFile);
	if(!file.exists()) {
		biobar_XMLFile="chrome://biobar/content/BiobarSearch.xml";
	} else {
		var uri = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(file);
		biobar_XMLFile = uri.spec;
	}

	var biobar_xmlFile=biobar_load_XMLFile(biobar_XMLFile);

	const pageDocument = document.getElementById("biobar-options-iframe").contentDocument;
	var popup = pageDocument.getElementById('biobar_default.popup');
	var database = pageDocument.getElementById('biobar.default.database');
	try {	database.removeChild(popup);
	} catch(e) { alert(e); }
	var p = pageDocument.createElement('menupopup');
	p.setAttribute('id', "biobar_default.popup");
	p.setAttribute('crop', "right");
	try {	
		var biobar_Menus = biobar_xmlFile.getElementsByTagName("Database");
	} catch(e) { alert(e); }
	for (var i=0; i<biobar_Menus.length; i++) {
		var tmp = biobar_Menus[i].getAttribute("type");
		var tmp_items = pageDocument.createElement('menuitem');
		tmp_items.setAttribute('label', tmp);
		tmp_items.setAttribute('value', tmp);
		p.appendChild(tmp_items);
	}
	database.appendChild(p);
}
